-- p2.py - MHS P2 definitions


-- @(#) $Header: /cs/research/pp/hubris/pp-beta/Format/rfc1148/RCS/p2.py,v 5.0 90/09/20 16:02:20 pp Exp Locker: pp $
--
-- $Log:	p2.py,v $
-- Revision 5.0  90/09/20  16:02:20  pp
-- rcsforce : 5.0 public release
-- 
--



P2 DEFINITIONS IMPLICIT TAGS ::=

BEGIN

-- IPM

IPM ::= SEQUENCE {
    heading	 			Heading,
    body				Body
    }

-- Heading

Heading ::= SET {
	this-IPM			ThisIPMField,
	originator		[0]	OriginatorField OPTIONAL,
	authorizing-users	[1]	AuthorizingUsersField OPTIONAL,
	primary-recipients	[2]	PrimaryRecipientsField DEFAULT {},
	copy-recipients		[3]	CopyRecipientsField OPTIONAL,
	blind-copy-recipients	[4]	BlindCopyRecipientsField OPTIONAL,
	replied-to-IPM		[5]	RepliedToIPMField OPTIONAL,
	obsoleted-IPMs		[6]	ObsoletedIPMsField DEFAULT {},
	related-IPMs		[7]	RelatedIPMsField DEFAULT {},
	subject			[8]	EXPLICIT SubjectField OPTIONAL,
	expiry-time		[9]	ExpiryTimeField OPTIONAL,
	reply-time		[10]	ReplyTimeField OPTIONAL,
	reply-recipients	[11]	ReplyRecipientsField OPTIONAL,
	importance		[12]	ImportanceField DEFAULT normal,
	sensitivity		[13]	SensitivityField OPTIONAL,
	auto-forwarded		[14]	AutoForwardedField DEFAULT FALSE,
	extensions		[15]	ExtensionsField DEFAULT {}
	}

-- Heading components types

IPMIdentifierSequence ::= SEQUENCE OF IPMIdentifier

IPMIdentifier ::= [APPLICATION 11] SET {
	user			       ORName OPTIONAL,
	user-relative-identifier       LocalIPMIdentifier
	}

LocalIPMIdentifier ::= PrintableString
        (SIZE (0..ub-local-ipm-identifier))

RecipientSequence ::= SEQUENCE OF RecipientSpecifier

RecipientSpecifier ::= SET {
	recipient	   	[0]	ORDescriptor,
	notification-requests	[1]	NotificationRequests DEFAULT {},
	reply-requested		[2]	BOOLEAN DEFAULT FALSE
	}

NotificationRequests ::= BIT STRING {
	rn(0),
	nrn(1),
	ipm-return(2)
	}

ORDescriptorSequence ::= SEQUENCE OF ORDescriptor

ORDescriptor ::= SET {
	formal-name  			ORName OPTIONAL,
	free-form-name		[0]	FreeFormName OPTIONAL,
	telephone-number	[1]	TelephoneNumber OPTIONAL
	}

FreeFormName ::= TeletexString (SIZE (0..ub-free-form-name))

TelephoneNumber ::= PrintableString (SIZE (0..ub-telephone-number))

-- This IPM heading field

ThisIPMField ::= IPMIdentifier

-- Originating heading field

OriginatorField ::= ORDescriptor

--Authorizing Users heading field

--AuthorizingUsersField ::= SEQUENCE OF AuthorizingUsersSubfield
	     
--AuthorizingUsersSubfield ::= ORDescriptor

-- To simplify coding

AuthorizingUsersField ::= ORDescriptorSequence

-- Primary Recipients heading field

--PrimaryRecipientsField ::= SEQUENCE OF PrimaryRecipientsSubfield

--PrimaryRecipientsSubfield ::= RecipientSpecifier

-- To simplify coding

PrimaryRecipientsField ::= RecipientSequence

-- Copy Recipients heading field

--CopyRecipientsField ::= SEQUENCE OF CopyRecipientsSubfield

--CopyRecipientsSubfield ::= RecipientSpecifier

-- To simplify coding

CopyRecipientsField ::= RecipientSequence

-- Blind Copy Recipients heading field

--BlindCopyRecipientsField ::= SEQUENCE OF BlindCopyRecipientsSubfield

--BlindCopyRecipientsSubfield ::= RecipientSpecifier

BlindCopyRecipientsField ::= RecipientSequence

-- Replied-to IPM heading field

RepliedToIPMField ::= IPMIdentifier

-- Obsoleted IPMs heading field

--ObsoletedIPMsField ::= SEQUENCE OF ObsoletedIPMsSubfield

--ObsoletedIPMsSubfield ::= IPMIdentifier

-- To simplify coding

ObsoletedIPMsField ::= IPMIdentifierSequence

-- Related IPMs heading field

--RelatedIPMsField ::= SEQUENCE OF RelatedIPMsSubfield

--RelatedIPMsSubfield ::= IPMIdentifier

-- To simplify coding

RelatedIPMsField ::= IPMIdentifierSequence

-- Subject heading field

SubjectField ::= TeletexString (SIZE (0..ub-subject-field))

-- Expiry Time heading field

ExpiryTimeField ::= Time

-- Reply Time heading field

ReplyTimeField ::= Time

-- Reply Recipients heading field

--ReplyRecipientsField ::= SEQUENCE OF ReplyRecipientsSubfield

--ReplyRecipientsSubfield ::= ORDescriptor

-- To simplify coding

ReplyRecipientsField ::= ORDescriptorSequence

-- Importance heading field

ImportanceField ::= ENUMERATED {
	low		       		(0),
	normal				(1),
	high				(2)
	}

-- Sensitivity heading field

SensitivityField ::= ENUMERATED {
	personal	       		(1),
	private				(2),
	company-confidential		(3)
	}
	
-- Auto-forwarded heading field

AutoForwardedField ::= BOOLEAN

-- Extensions heading field

ExtensionsField ::= SET OF HeadingExtension

HeadingExtension ::= SEQUENCE {
	type		      		OBJECT IDENTIFIER,
	value				ANY 
}

-- Incomplete Copy

IncompleteCopy ::= NULL

Languages ::= SET OF Language

Language ::= PrintableString (SIZE (2..2))

RFC822Field ::= IA5String

-- Body

Body ::= ANY

-- IPN

IPN ::= SET {
	-- common-fields
	subject-ipm			SubjectIPMField,
	ipn-originator		[1]	IPNOriginatorField OPTIONAL,
	ipm-preferred-recipient	[2]	IPMPreferredRecipientField OPTIONAL,
	conversion-eits			ConversionEITsField OPTIONAL,
	choice [0] CHOICE {
	       non-receipt-fields	[0]	NonReceiptFields,
	       receipt-fields		[1]	ReceiptFields
	       }
	}

NonReceiptFields ::= SET {
	non-receipt-reason	[0]	NonReceiptReasonField,
	discard-reason		[1]	DiscardReasonField OPTIONAL,
	auto-forward-comment	[2]	AutoForwardCommentField OPTIONAL,
	returned-ipm		[3]	ReturnedIPMField OPTIONAL
	}

ReceiptFields ::= SET {
	receipt-time  		[0] 	ReceiptTimeField,
	acknowledgment-mode	[1]	AcknowledgmentModeField DEFAULT manual,
	suppl-receipt-info	[2] 	SupplReceiptInfoField DEFAULT ""
	}

-- Common fields

SubjectIPMField ::= IPMIdentifier

IPNOriginatorField ::= ORDescriptor

IPMPreferredRecipientField ::= ORDescriptor

ConversionEITsField ::= EncodedInformationTypes

-- Non-receipt fields

NonReceiptReasonField ::= ENUMERATED {
	ipm-discarded		     	(0),
	ipm-auto-forward		(1)
	}

DiscardReasonField ::= ENUMERATED {
	ipm-expired		  	(0),
	ipm-obsoleted			(1),
	user-subscription-terminated	(2)
	}

AutoForwardCommentField ::= AutoForwardComment

AutoForwardComment ::= PrintableString
	(SIZE (0..ub-auto-forward-comment))

ReturnedIPMField ::= IPM

-- Receipt fields

ReceiptTimeField ::= Time

AcknowledgmentModeField ::= ENUMERATED {
	manual			       (0),
	automatic		       (1)
	}

-- SupplReceiptInfoField ::= SupplementaryInformation

SupplReceiptInfoField ::= PrintableString
	(SIZE (1..ub-supplementary-info-length))

Time ::= UTCTime
Name ::= ANY -- for now...

ORName ::= [APPLICATION 0] SEQUENCE {
        x1 ANY,
	x2 ANY OPTIONAL}
--	standard-attributes StandardAttributes,
--	domain-defined DomainDefinedAttributes OPTIONAL,
--	extension-attributes ExtensionAttributes OPTIONAL,
--	directory-name [0] Name OPTIONAL }

--ORAddress ::= SEQUENCE {
--	x1 ANY,
--	x2 ANY OPTIONAL}
--	standard-attributes StandardAttributes,
--	domain-defined-attributes DomainDefinedAttributes OPTIONAL,
	-- see also teletex-domain-defined-attributes
--	extension-attributes ExtensionAttributes OPTIONAL }


--	Standard Attributes

StandardAttributes ::= SEQUENCE {
	country-name CountryName OPTIONAL,
	administration-domain-name AdministrationDomainName OPTIONAL,
	network-address [0] NetworkAddress OPTIONAL,
	-- see also extended-network-address
	terminal-identifier [1] TerminalIdentifier OPTIONAL,
	private-domain-name [2] PrivateDomainName OPTIONAL,
	organization-name [3] OrganizationName OPTIONAL,
	-- see also teletex-organization-name
	numeric-user-identifier [4] NumericUserIdentifier OPTIONAL,
	personal-name [5] PersonalName OPTIONAL,
	organizational-unit-names [6] OrganizationalUnitNames OPTIONAL
	-- see also teletex-organizational-unit-names -- }

CountryName ::= [APPLICATION 1] CHOICE {
	x121-dcc-code NumericString (SIZE (ub-country-name-numeric-length)),
	iso-3166-alpha2-code PrintableString (SIZE (ub-country-name-alpha-length))
}

AdministrationDomainName ::= [APPLICATION 2] CHOICE {
	numeric NumericString (SIZE (0..ub-domain-name-length)),
	printable PrintableString (SIZE (0..ub-domain-name-length))
}

NetworkAddress ::= X121Address

X121Address ::= NumericString (SIZE (1..ub-x121-address-length))

TerminalIdentifier ::= PrintableString (SIZE (1..ub-terminal-id-length))

PrivateDomainName ::= CHOICE {
	numeric NumericString (SIZE (1..ub-domain-name-length)),
	printable PrintableString (SIZE (1..ub-domain-name-length))
}

OrganizationName ::= PrintableString (SIZE (1..ub-organization-name-length))

NumericUserIdentifier ::= NumericString (SIZE (1..ub-numeric-user-id-length))

PersonalName ::= SET {
	surname [0] PrintableString (SIZE (1..ub-surname-length)),
	given-name [1] PrintableString (SIZE (1..ub-given-name-length)) OPTIONAL,
	initials [2] PrintableString (SIZE (1..ub-initials-length)) OPTIONAL,
	generation-qualifier [3] PrintableString (SIZE (1..ub-generation-qualifier-length)) OPTIONAL }

OrganizationalUnitNames ::= SEQUENCE SIZE (1..ub-organizational-units) OF OrganizationUnitName 

OrganizationUnitName ::= PrintableString (SIZE (1..ub-organizational-unit-name-length))

--	Domain-defined Attributes

DomainDefinedAttributes ::= SEQUENCE SIZE (1..ub-domain-defined-attributes) OF DomainDefinedAttribute 

DomainDefinedAttribute ::= SEQUENCE {
	type PrintableString (SIZE (1..ub-domain-defined-attribute-type-length)),
	value PrintableString (SIZE (1..ub-domain-defined-attribute-value-length)) }

-- Extension Attributes

ExtensionAttribute ::=
    SEQUENCE {
         type  [0] INTEGER,
         value [1] ANY}

ExtensionAttributes ::=
    SET OF ExtensionAttribute

--	EncodedInformation Types

EncodedInformationTypes ::= [APPLICATION 5] SET {
	built-in-encoded-information-types [0] BuiltInEncodedInformationTypes,
--	non-basic-parameters COMPONENTS OF NonBasicParameters,
	external-encoded-information-types [4] ExternalEncodedInformationTypes OPTIONAL }

--	Built-in Encoded Information Types

BuiltInEncodedInformationTypes ::= BIT STRING {
	undefined (0),
	telex (1),
	ia5-text (2),
	g3-facsimile (3),
	g4-class-1 (4),
	teletex (5),
	videotex (6),
	voice (7),
	sfd (8),
	mixed-mode (9) } (SIZE (0..ub-built-in-encoded-information-types))

--	Non-basic Parameters

NonBasicParameters ::= SET {
	g3-facsimile [1] G3FacsimileNonBasicParameters DEFAULT { },
	teletex [2] TeletexNonBasicParameters DEFAULT { },
	g4-class-1-and-mixed-mode [3] G4Class1AndMixedModeNonBasicParameters OPTIONAL }

G3FacsimileNonBasicParameters ::= BIT STRING {
	two-dimensional (8),
	fine-resolution (9),
	unlimited-length (20),
	b4-length (21),
	a3-width (22),
	b4-width (23),
	uncompressed (30) }			-- as defined in [|CCITT] Recommendation T.30

TeletexNonBasicParameters ::= SET {
	graphic-character-sets [0] TeletexString OPTIONAL,
	control-character-sets [1] TeletexString OPTIONAL,
	page-formats [2] OCTET STRING OPTIONAL,
	miscellaneous-terminal-capabilities [3] TeletexString OPTIONAL,
	private-use [4] OCTET STRING OPTIONAL	-- maximum ub-teletex-private-use-length octets -- }
	-- as defined in [|CCITT] Recommendation T.62

G4Class1AndMixedModeNonBasicParameters ::= PresentationCapabilities

PresentationCapabilities ::= ANY		-- as defined in [|CCITT] Recommendations T.400, T.503 and T.501


--	External Encoded Information Types

ExternalEncodedInformationTypes ::= SET SIZE (1..ub-encoded-information-types) OF 
	ExternalEncodedInformationType

ExternalEncodedInformationType ::= OBJECT IDENTIFIER 

END 
