/* gen_ndr.c: generate the Non Delivery Notifications from submit */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Src/submit/RCS/gen_ndr.c,v 5.0 90/09/20 16:23:02 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Src/submit/RCS/gen_ndr.c,v 5.0 90/09/20 16:23:02 pp Exp Locker: pp $
 *
 * $Log:	gen_ndr.c,v $
 * Revision 5.0  90/09/20  16:23:02  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "head.h"
#include "q.h"
#include "dr.h"
#include <isode/cmd_srch.h>

extern Q_struct         Qstruct;
extern char             msg_fullpath[];
extern char		*loc_dom_site;
extern CMD_TABLE	rr_tcode[],
			rr_dcode[],
			rr_rcode[];


/* -- local routines -- */
void			gen_ndr();
static void		gen_ndrFORrecip();
static void		gen_ndrFORsender();
static void		set_DRvalues();




/*----------------------  Begin  Routines  -------------------------------- */




void gen_ndr()
{
	register Q_struct       *qp = &Qstruct;


	PP_TRACE (("submit/gen_ndr()"));

	if (qp -> Oaddress -> ad_status == AD_STAT_DRREQUIRED)
		gen_ndrFORsender();
	else 
		gen_ndrFORrecip();
}




static void gen_ndrFORsender()
{
	register Q_struct       *qp = &Qstruct;
	register ADDR           *ad,
				*sender;
	char			errbuf[LINESIZE];


	PP_TRACE (("submit/gen_ndrFORsender()"));

	sender = qp -> Oaddress;
	sender -> ad_status = AD_STAT_DONE;
	(void) sprintf (errbuf,
		"Bad sender address '%s' [%s], all recips are rejected",
		sender -> ad_value, sender -> ad_parse_message);

	if (qp -> queuetime == NULLUTC)
		qp -> queuetime = utcnow();

	for (ad = qp -> Raddress; ad != NULLADDR; ad = ad -> ad_next) {
		if (ad -> ad_status == AD_STAT_DONE)
			continue;

		ad -> ad_status = AD_STAT_DRREQUIRED;
		ad -> ad_reason = DRR_NO_REASON;
		if (ad -> ad_add_info)
			free (ad -> ad_add_info);
		ad -> ad_add_info = NULLCP;
		set_DRvalues (sender, ad, errbuf);
	}

	if (wr_q2drsubmit (qp, msg_fullpath) != RP_OK)
		PP_LOG (LLOG_EXCEPTIONS, ("wr_q2drsubmit failed"));

	return;
}




static void gen_ndrFORrecip()
{
	register Q_struct       *qp = &Qstruct;
	register ADDR           *ad,
				*sender;
	int                     recip_err = FALSE;


	PP_TRACE (("submit/gen_ndrFORrecip()"));

	sender = qp -> Oaddress;
	if (qp -> queuetime == NULLUTC)
		qp -> queuetime = utcnow();

	for (ad = qp -> Raddress; ad != NULLADDR; ad = ad -> ad_next) {
		if (ad -> ad_status != AD_STAT_PEND &&
		    ad -> ad_status != AD_STAT_DRREQUIRED)
			continue;

		if (rp_isbad (ad -> ad_parse_stat) ||
		    ad -> ad_status == AD_STAT_DRREQUIRED)
		{
			recip_err = TRUE;
			set_DRvalues (sender, ad, NULLCP);
		}
	}


	if (recip_err == FALSE) {
		PP_TRACE (("submit/gen_ndrFORrecip (not generated)"));
		return;
	}


	if (wr_q2drsubmit (qp, msg_fullpath) != RP_OK)
		PP_LOG (LLOG_EXCEPTIONS, ("wr_q2drsubmit failed"));

	return;
}


#define gval(x)                 ((x -> ad_type) == AD_X400_TYPE ? \
                                        (x -> ad_r400adr) : (x -> ad_r822adr))

static void set_DRvalues (sender, recip, errstr)
ADDR	*sender;
ADDR	*recip;
char	*errstr;
{
	char	*str, boundadd[BUFSIZ];
	int	freeit = 0;

	register Q_struct       *qp = &Qstruct;

	recip -> ad_type = sender -> ad_type;

	if (recip -> ad_reason == DRR_NO_REASON) {
		recip -> ad_reason = DRR_UNABLE_TO_TRANSFER;
		recip -> ad_diagnostic = DRD_UNRECOGNISED_OR;
	}

	if ((str = recip -> ad_add_info) == NULLCP) {
		if (errstr)
			str = errstr;
		else 
			(void) sprintf (str = boundadd,
					"Bad recipient address '%s' [%s]",
					recip -> ad_value,
					rp_valstr (recip -> ad_parse_stat));
	}
	else
		freeit = 1;
	set_1dr (qp, recip -> ad_no, recip -> ad_reason,
		 recip -> ad_diagnostic, str);
	if (freeit)
		free (str);
}

